
' .ApplicationSource CRV-Atlas(1.0)'!

'From VisualWorks(R), Release 2.5 of September 26, 1995 on August 22, 1997 at 3:11:27 pm'!

'- user-strings of CRV-Atlas(1.0) -'!

#('name' 'CRV-Atlas' 'version' '1.0')!

'required applications for CRV-Atlas(1.0)'!

Message
	selector: #checkRequired:
	argument: #()!

'- source of CRV-Atlas(1.0) -'!



ControllerWithMenu subclass: #AtlasController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atlas'!

!AtlasController methodsFor: 'initialize-release'!

initialize

	super initialize.
	self menuHolder: self class yellowButtonMenu asValue.! !

!AtlasController methodsFor: 'menu messages'!

cmEurope

	self model europe!

cmInspect

	self model inspect!

cmNorthAmerica

	self model northAmerica!

cmPrintEps

	self view printEps!

cmSouthAmerica

	self model southAmerica!

cmUpdate

	self model changed!

cmWorld

	self model world! !

!AtlasController methodsFor: 'model access'!

modelOld: aModel 

	self performer: aModel.
	super model: aModel! !

!AtlasController class methodsFor: 'resources'!

yellowButtonMenu
	"UIMenuEditor new openOnClass: self andSelector: #yellowButtonMenu"

	<resource: #menu>
	^#(#Menu #(
			#(#MenuItem 
				#rawLabel: 'range' 
				#submenu: #(#Menu #(
						#(#MenuItem 
							#rawLabel: 'world' 
							#value: #cmWorld ) 
						#(#MenuItem 
							#rawLabel: 'europe' 
							#value: #cmEurope ) 
						#(#MenuItem 
							#rawLabel: 'north america' 
							#value: #cmNorthAmerica ) 
						#(#MenuItem 
							#rawLabel: 'south america' 
							#value: #cmSouthAmerica ) ) #(4 ) nil ) ) 
			#(#MenuItem 
				#rawLabel: 'print PS/EPS...' 
				#value: #cmPrintEps ) 
			#(#MenuItem 
				#rawLabel: 'inspect' 
				#value: #cmInspect ) 
			#(#MenuItem 
				#rawLabel: 'update' 
				#value: #cmUpdate ) ) #(2 2 ) nil ) decodeAsLiteralArray! !

CurvePainter subclass: #Atlas
	instanceVariableNames: 'vertices range grid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atlas'!

!Atlas methodsFor: 'initialize-release'!

initialize

	| temp1 temp2 |

	super initialize.

	temp1 := #(
		"UK"
		((-6 50) (-2 51) (2 52) (2 54) (-2 56) (-3 58) (-6 56) (-4 54) (-6 52) (-3 52) (-6 50))
		"Irland"
		((-10 52) (-6 52) (-6 55) (-10 54) (-10 52))
		"Spitzbergen"
		((16 76) (11 80) (20 81) (27 80) (16 76))
		"Island"
		((-18 64) (-14 66) (-15 67) (-21 66) (-24 67) (-24 65) (-18 64))
		"Europa, Skandinavien, Asien, Afrika"
		((-8 37) (-9 40) (-9 43) (-5 43) (-2 43) (-2 46) (-5 48) (-2 48) (-2 50) (2 50) (2 51)
		(6 54) (8 54) (8 57) (11 57) (10 55) (11 54) (13 55) (15 54) (18 55) (22 55) (23 57)
		(24 56) (24 59) (27 59) (30 60) (27 61) (23 60) (22 63) (26 65) (24 66) (19 63)
		(20 60) (17 58) (16 56) (13 56) (11 60) (7 57) (7 62) (10 64) (13 67) (18 70) (22 70)
		(26 72) (32 70) (35 69) (42 68) (38 67) (33 67) (35 65) (37 67) (35 66) (40 65)
		(42 67) (44 69) (46 68) (47 67) (54 69) (60 70) (53 73) (60 76) (68 77) (60 75)
		(55 72) (60 70) (68 68) (69 73) (73 73) (70 67) (75 71) (80 74) (86 73) (90 76)
		(95 76) (100 76) (105 77) (110 76) (113 74) (118 73) (123 73) (128 73) (131 71)
		(135 72) (140 72) (145 73) (150 73) (155 71) (160 71) (165 69) (170 70) (175 70)
		(180 68) (-175 68) (-171 67) (-173 64) (-176 66) (180 67) (178 65) (180 63) (175 62)
		(170 60) (165 60) (162 58) (162 55) (160 53) (157 51) (155 55) (157 57) (160 59)
		(165 63) (160 61) (157 62) (155 59) (150 59) (145 59) (140 58) (135 55) (140 54)
		(141 51) (140 48) (136 44) (133 43) (130 43) (128 39) (129 35) (126 34) (126 38)
		(124 40) (121 38) (122 41) (117 39) (119 37) (123 37) (119 35) (122 32) (120 30)
		(122 30) (120 27) (117 23) (114 22) (110 21) (108 22) (106 20) (108 16) (109 13)
		(105 9) (103 11) (100 13) (100 9) (103 5) (104 1) (101 5) (98 10) (98 14) (97 17)
		(94 17) (93 20) (92 23) (87 22) (85 19) (81 16) (80 13) (80 10) (77 8) (75 13) (73 17)
		(73 22) (71 21) (68 23) (66 25) (62 25) (57 26) (54 26) (51 29) (50 30) (48 29)
		(51 26) (52 24) (56 26) (60 23) (57 19) (52 16) (47 14) (43 13) (43 17) (39 22)
		(37 25) (35 28) (35 25) (37 22) (38 18) (41 15) (44 12) (47 12) (51 13) (49 6) (46 3)
		(43 0) (40 -4) (39 -7) (41 -11) (41 -16) (37 -17) (35 -20) (35 -24) (33 -26) (32 -30)
		(28 -33) (25 -34) (20 -35) (18 -33) (16 -28) (14 -23) (13 -20) (12 -17) (13 -14)
		(14 -11) (14 -8) (12 -4) (9 0) (10 5) (6 5) (4 6) (-1 5) (-7 4) (-11 6) (-14 10) (-16 13)
		(-16 17) (-16 21) (-14 24) (-10 30) (-6 33) (-5 36) (-2 35) (1 37) (5 37) (10 37) (10 33)
		(15 32) (20 31) (20 33) (22 33) (26 32) (31 32) (34 32) (36 37) (31 37) (27 37)
		(26 41) (23 40) (25 36) (23 35) (20 40) (19 42) (13 45) (12 44) (18 40) (16 38)
		(16 40) (12 42) (8 44) (5 43) (3 43) (0 40) (-3 36) (-6 36) (-8 37))
		"Sewernaja, Semlja"
		((100 78) (105 78) (95 82) (91 80) (100 78))
		"Neusibirische Inseln"
		((137 75) (150 75) (138 76) (137 75))
		"Japanische Inseln"
		((142 46) (142 50) (142 54) (144 49) (142 46) (140 41) (140 38) (136 36) (133 35)
		(130 34) (131 31) (132 33) (136 34) (140 35) (141 38) (141 42) (145 43) (142 45))
		"Philippinen"
		((121 18) (124 13) (125 6))
		"Indonesien 1"
		((105 -5) (100 0) (95 5) (100 3) (103 0) (105 -5) (110 -7) (115 -8) (120 -9) (125 -8))
		"Indonesien 2"
		((115 8) (110 2) (110 -3) (115 -4) (118 0) (118 5) (115 8))
		"Indonesien 3"
		((125 2) (120 0) (120 -5))
		"Neuguinea"
		((123 -5) (120 -2) (125 -2) (130 -3) (135 -6) (138 -8) (142 -8) (145 -5) (150 -10)
		(145 -3) (140 -3) (135 -2) (130 -3))
		"Salomonen"
		((148 -5) (155 -8) (160 -10))
		"Sri Lanka"
		((80 10) (80 6) (82 7) (80 10))
		"Madagaskar"
		((49 -12) (44 -16) (44 -21) (43 -23) (45 -26) (47 -25) (48 -20) (51 -15) (49 -12))
		"Schwarzes Meer"
		((38 47) (34 45) (36 45) (34 44) (33 46) (28 43) (30 42) (35 43) (40 42) (42 43)
		(36 45) (38 47))
		"Kaspisches Meer"
		((50 41) (48 37) (53 36) (53 42) (50 46) (53 47) (47 46) (50 41))
		"Aralsee"
		((58 44) (61 44) (62 47) (59 46) (58 44))
		"Australien"
		((143 -11) (145 -15) (147 -20) (152 -24) (153 -28) (153 -32) (150 -37) (146 -38)
		(141 -37) (138 -35) (136 -35) (132 -32) (127 -33) (123 -34) (118 -35) (115 -33)
		(115 -29) (114 -25) (114 -22) (118 -21) (121 -20) (123 -16) (126 -14) (130 -15)
		(131 -12) (136 -13) (135 -15) (140 -17) (142 -15) (143 -11))
		"Neuseeland"
		((175 -42) (178 -38) (173 -35) (175 -42) (170 -45) (166 -45) (172 -41) (175 -42))
		"Gr├Ânland"
		((-70 76) (-60 76) (-55 73) (-54 68) (-51 63) (-44 60) (-44 65) (-33 67) (-23 70)
		(-20 74) (-20 78) (-15 82) (-30 83) (-40 83) (-50 83) (-60 83) (-70 83) (-80 83)
		(-90 83) (-97 80) (-90 75) (-80 75) (-70 76))
		"Nord- und S├╝damerika"
		((-80 70) (-74 67) (-78 65) (-72 64) (-65 63) (-62 67) (-70 71) (-80 73) (-90 73)
		(-86 70) (-80 70) (-84 66) (-80 64) (-90 64) (-95 60) (-90 57) (-86 56) (-82 56)
		(-80 52) (-79 56) (-76 58) (-76 62) (-70 62) (-68 58) (-64 61) (-62 56) (-57 54)
		(-55 52) (-54 48) (-59 48) (-54 52) (-62 50) (-66 50) (-71 47) (-66 49) (-65 46)
		(-60 46) (-65 45) (-70 45) (-74 40) (-76 36) (-82 32) (-80 27) (-82 25) (-84 30)
		(-89 30) (-94 29) (-97 26) (-97 22) (-95 18) (-91 18) (-90 21) (-86 21) (-88 16)
		(-84 16) (-84 10) (-80 10) (-76 8) (-72 12) (-67 11) (-62 10) (-58 7) (-53 5) (-50 1)
		(-46 -2) (-42 -3) (-37 -5) (-35 -8) (-37 -12) (-38 -17) (-40 -20) (-43 -23) (-47 -24)
		(-48 -28) (-52 -32) (-55 -35) (-58 -35) (-56 -37) (-60 -39) (-65 -42) (-66 -46) (-65 -47)
		(-67 -50) (-65 -55) (-70 -55) (-74 -52) (-74 -47) (-74 -42) (-74 -38) (-72 -33) (-72 -28)
		(-71 -23) (-71 -18) (-75 -15) (-78 -11) (-81 -6) (-81 -1) (-78 2) (-77 5) (-77 8) (-82 7)
		(-86 10) (-90 13) (-95 16) (-97 16) (-102 17) (-106 20) (-106 23) (-110 27) (-113 32)
		(-113 27) (-110 23) (-115 27) (-116 32) (-120 34) (-123 37) (-124 43)
		"(-125 47) (-127 51) (-131 54)"
		(-125 48) (-122 48) (-124 50) (-128 51.5) (-130 53)
		(-138 58) (-144 60) (-150 60) (-155 56) (-163 55) (-157 58)
		(-163 58) (-166 62) (-161 65) (-168 66) (-162 67) (-165 68) (-158 72) (-149 71)
		(-140 69) (-135 68) (-130 70) (-122 69) (-115 68) (-108 68) (-100 68) (-95 70)
		(-88 72) (-80 70))
		"Vancouver"
		((-128 50.8) (-126 50.3) (-123.5 48.5) (-125 48.5) (-129 50.5) (-128 50.8))
		"Victoriainsel"
		((-125 74) (-125 72) (-115 72) (-115 69) (-110 68) (-101 69) (-105 74) (-115 73)
		(-125 74))
		"Gro├ƒe Antillen"
		((-85 22) (-80 23) (-75 20) (-70 18) (-65 18) (-62 15))
		"Antarktika"
		((-60 -63) (-65 -66) (-60 -72) (-50 -75) (-40 -76) (-30 -75) (-20 -72) (-10 -70) (0 -70)
		(10 -70) (20 -72) (30 -69) (40 -70) (50 -65) (60 -67) (70 -70) (80 -68) (90 -66)
		(100 -65) (110 -67) (120 -67) (130 -65) (140 -65) (150 -70) (160 -70) (170 -73)
		(165 -78) (177 -78) (-171 -78) (-169 -78) (-160 -78) (-150 -74) (-140 -73)
		(-130 -72) (-120 -70) (-110 -72) (-100 -70) (-90 -70) (-80 -70) (-75 -68) (-63 -65)
		(-60 -63))).

	vertices := Array new: temp1 size.
	temp1 keysAndValuesDo: [ :i1 :t1 |
		temp2 := Array new: t1 size.
		t1 keysAndValuesDo: [ :i2 :t2 |
			temp2 at: i2 put: (t2 at: 1) @ (t2 at: 2).
		].
		vertices at: i1 put: temp2.
	].

	self world.
	grid := 15.0. "0.0 means no grid"! !

!Atlas methodsFor: 'accessing'!

grid: aFloat

	grid := aFloat!

range: aRectangle

	range = aRectangle ifFalse: [
		range := aRectangle.
		self changed.
	].!

style: aCurves

	(self style == aCurves) ifFalse: [
		self style notNil ifTrue: [
			self style removeDependent: self; closeAllWindows.
		].
		style := aCurves.
		self style addDependent: self.
	].
	"self changed"! !

!Atlas methodsFor: 'constants'!

europe

	self range: self class europe!

northAmerica

	self range: self class northAmerica!

southAmerica

	self range: self class southAmerica!

world

	self range: self class world! !

!Atlas methodsFor: 'displaying'!

displayWithLinesOn: aGraphicsContext

	| margin extent matrix p1 p2 maxDist collection |

	margin := 0.0.
	extent := aGraphicsContext medium bounds extent.
	matrix := Matrix3x3
		withScalingFrom: range
		to: (Rectangle origin: margin@(extent y - margin) corner: (extent x - margin)@margin).
	maxDist := (extent x min: extent y) * 80 percent.

	grid = 0.0 ifFalse: [
		| start |
		aGraphicsContext lineWidth: 0.5; paint: ColorValue veryLightGray.
		""
		start := 180.0 - (grid / 2.0) roundTo: grid.
		start negated to: start + (grid / 2.0) by: grid do: [ :i |
			aGraphicsContext displayLineFrom: matrix * (i @ -90.0) to: matrix * (i @ 90.0).
		].

		""
		start := 90.0 - (grid / 2.0) roundTo: grid.
		start negated to: start + (grid / 2.0) by: grid do: [ :i |
			aGraphicsContext displayLineFrom: matrix * (-180.0 @ i) to: matrix * (180.0 @ i).
		].
	].

	aGraphicsContext lineWidth: 1.0; paint: ColorValue black.
	""
	p1 := -10000.0 @ -10000.0.
	vertices do: [ :v |
		collection := OrderedCollection new: 100.
		v do: [ :p |
			p2 := matrix * p.
			(p1 dist: p2) > maxDist ifTrue: [
				collection size > 1 ifTrue: [aGraphicsContext displayPolyline: collection].
				collection := OrderedCollection new: 100.
			].
			collection add: p2.
			p1 := p2.
		].
		collection size > 1 ifTrue: [aGraphicsContext displayPolyline: collection].
	].

	"Screen default ringBell"!

displayWithStyleOn: aGraphicsContext

	| margin extent matrix p1 p2 maxDist crv collection |

	margin := 0.0.
	extent := aGraphicsContext medium bounds extent.
	matrix := Matrix3x3
		withScalingFrom: range
		to: (Rectangle origin: margin@(extent y - margin) corner: (extent x - margin)@margin).
	maxDist := (extent x min: extent y) * 80 percent.

	grid = 0.0 ifFalse: [
		| start |
		aGraphicsContext lineWidth: 0.5; paint: ColorValue veryLightGray.
		""
		start := 180.0 - (grid / 2.0) roundTo: grid.
		start negated to: start + (grid / 2.0) by: grid do: [ :i |
			collection := OrderedCollection
				with: (ControlPoint
					coordinates: matrix * (i @ -90.0)
					weight: 1.0
					pressure: 0.5
					saturation: 0.2)
				with: (ControlPoint
					coordinates: matrix * (i @ 90.0)
					weight: 1.0
					pressure: 0.5
					saturation: 0.2).
			crv := (Path controlPoints: collection interpolation: #polyline cyclic: false)
				package: #atlas; type: #grid.
			self style displayCurve: crv on: aGraphicsContext.
		].

		""
		start := 90.0 - (grid / 2.0) roundTo: grid.
		start negated to: start + (grid / 2.0) by: grid do: [ :i |
			collection := OrderedCollection
				with: (ControlPoint
					coordinates: matrix * (-180.0 @ i)
					weight: 1.0
					pressure: 0.5
					saturation: 0.2)
				with: (ControlPoint
					coordinates: matrix * (180.0 @ i)
					weight: 1.0
					pressure: 0.5
					saturation: 0.2).
			crv := (Path controlPoints: collection interpolation: #polyline cyclic: false)
				package: #atlas; type: #grid.
			self style displayCurve: crv on: aGraphicsContext.
		].
	].

	""
	p1 := -10000.0 @ -10000.0.
	vertices keysAndValuesDo: [ :q :v |
		collection := OrderedCollection new: 100.
		v do: [ :p |
			p2 := ControlPoint coordinates: matrix * p.
			(p1 dist: p2) > maxDist ifTrue: [
				collection size > 1 ifTrue: [
					crv := (Path controlPoints: collection) package: #atlas;
						type: ((q in: #(17 18 19)) ifTrue: [#lake] ifFalse: [#coast]).
					self style displayCurve: crv on: aGraphicsContext.
				].
				collection := OrderedCollection new: 100.
			].
			collection add: p2.
			p1 := p2.
		].
		collection size > 2 ifTrue: [
			crv := (Path controlPoints: collection) package: #atlas;
				type: ((q in: #(17 18 19)) ifTrue: [#lake] ifFalse: [#coast]).
			self style displayCurve: crv on: aGraphicsContext.
		].
	].

	"Screen default ringBell"! !

!Atlas class methodsFor: 'constants'!

europe

	^Rectangle origin: -20@30 corner: 40@70!

northAmerica

	^Rectangle origin: -170@10 corner: -50@90!

southAmerica

	^Rectangle origin: -120@-60 corner: 0@20!

world

	^Rectangle origin: -180@-120 corner: 180@120! !

!Atlas class methodsFor: 'examples'!

animate
	"Atlas animate"

	| n extent writer pm gc atlas |

	n := 100. "Picture 0 ... n-1"
	extent := 300@200.

	writer := AnimatedGIFReadWriter on: ('anim.gif' asFilename writeStream).
	writer loopCount: 0; delay: 5; transparentIndex: nil.
	pm := (Pixmap extent: extent) background: ColorValue white.
	gc := pm graphicsContext.
	atlas := self style: (Style loadTxt: Style defaultTxtPath, 'bla.crv').
	atlas grid: 0.0.

	[
		UserActivityInformer
			header: 'Atlas animate';
			information: 'Create ', n asString, ' Pictures.';
			steps: n.
		self world animateTo: self europe steps: n - 1 block: [ :r |
			atlas range: r; displayWithStyleOn: "displayWithLinesOn:" gc clear.
			writer nextPutImage: pm asImage.
			UserActivityInformer step.
		].
		
		n := 20.
		UserActivityInformer
			header: 'Atlas animate';
			information: 'Create ', n asString, ' Pictures.';
			steps: n.
		self europe animateTo: self world steps: n - 1 block: [ :r |
			atlas range: r; displayWithStyleOn: "displayWithLinesOn:" gc clear.
			writer nextPutImage: pm asImage.
			UserActivityInformer step.
		].
		
		UserActivityInformer information: 'Done.'
	] valueNowOrOnUnwindDo: [writer close].

	"atlas release."!

example
	"Atlas example"

	| pathStyle |	

	pathStyle := self style:
		(StyleCatalog loadTxt: StyleCatalog defaultTxtPath, 'test.cat').

	ScheduledWindow new
		label: 'Atlas';
		minimumSize: 600@400;
		component: (AtlasView model: pathStyle);
		background: ColorValue white;
		open.! !

View subclass: #AtlasView
	instanceVariableNames: 'updateProcess '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atlas'!

!AtlasView methodsFor: 'initialize-release'!

release

	self checkProcess.
	self model release.
	super release.! !

!AtlasView methodsFor: 'controller accessing'!

defaultControllerClass

	^AtlasController! !

!AtlasView methodsFor: 'displaying'!

displayOn: aGraphicsContext

	self checkProcess.
	updateProcess :=
		[self model displayWithStyleOn: aGraphicsContext]
		"[self model displayWithLinesOn: aGraphicsContext]"
			forkAt: Processor userBackgroundPriority
	"model displayOn: aGraphicsContext"! !

!AtlasView methodsFor: 'save txt / print eps'!

printEpsOn: aPostScriptFile

	self displayOn: aPostScriptFile graphicsContext! !

!AtlasView methodsFor: 'private'!

checkProcess

	updateProcess notNil ifTrue: [updateProcess terminate]! !


